; by Jautois - 2010
; Version: 0.2

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <GDIPlus.au3>
#include <IE.au3>
#include <Sound.au3>
#include <Timers.au3>
#include <WinAPI.au3>
#include <Date.au3>

Global $aAverage[1]
Global $iLastID = ""
Global $iCurResult = ""
Global $iCurStatus = -1
Global $iRight = 0
Global $iWrong = 0
Global $iLastAt = ""
Global $iLastUResult = ""
Global $iAverageTime = 0
Global $iTimer, $iTimeSave = 0, $iArithTime
Global $pInput_HighRange, $pInput_LowRange
Global $sIcon = @ScriptDir & "\form.ico"
Global $hGraphic, $hPen
Global $iSq = False

Global $sSound_Right = _SoundOpen(@ScriptDir & "\clap.wav")
Global $sSound_Wrong = _SoundOpen(@ScriptDir & "\boo.wav")

$hWindow = GUICreate("KT - KopfrechenTrainer by Jautois v.0.1", 514, 658)
GUIRegisterMsg($WM_COMMAND, "_Range")
GUISetIcon($sIcon)
GUISetFont(8, 400, 0, "Verdana")
GUICtrlCreateGroup("Einstellungen", 8, 8, 497, 233)
GUICtrlCreateGroup("Zahlenbereich [-1000 bis +1000]", 16, 32, 329, 65)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Rechenarten", 16, 104, 329, 129)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("Sonstiges", 352, 32, 145, 201)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateLabel("bis", 152, 64, 20, 17)
$pInput_LowRange = GUICtrlCreateInput("-10", 69, 58, 65, 21)
GUICtrlCreateUpdown(-1)
GUICtrlCreateLabel("Von", 37, 64, 26, 17)
$pInput_HighRange = GUICtrlCreateInput("10", 181, 58, 57, 21)
GUICtrlCreateUpdown(-1)
GUICtrlCreateGroup("Aufgabe", 8, 248, 497, 361)
$pInput_Result = GUICtrlCreateInput("10", 360, 277, 129, 33)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetState(-1, $GUI_DISABLE)
GUICtrlSetColor(-1, 0xC0C0C0)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$pCheckbox_Add = GUICtrlCreateCheckbox("Addition", 40, 128, 97, 25)
GUICtrlSetState(-1, $GUI_CHECKED)
$iLastID = $pCheckbox_Add
$pCheckbox_Sub = GUICtrlCreateCheckbox("Subtraktion", 40, 152, 97, 25)
$pCheckbox_Mult = GUICtrlCreateCheckbox("Multiplikation", 40, 176, 97, 25)
$pCheckbox_Div = GUICtrlCreateCheckbox("Division", 40, 200, 97, 25)
$pCheckbox_Sqrt = GUICtrlCreateCheckbox("Wurzel", 168, 128, 97, 25)
$pCheckbox_Pot = GUICtrlCreateCheckbox("Potenzen", 168, 152, 97, 25)
$pCheckbox_Rand = GUICtrlCreateCheckbox("Zufllige Rechenart", 168, 176, 130, 25)
$pCheckbox_Sound = GUICtrlCreateCheckbox("Sound", 368, 56, 89, 17)
$pLabel_Sum = GUICtrlCreateLabel("3 + 7", 85, 280, 230, 29, $SS_CENTER)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0xC0C0C0)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)
GUICtrlCreateLabel("=", 328, 272, 30, 42)
GUICtrlSetFont(-1, 24, 400, 0, "Verdana")
$pLabel_Output = GUICtrlCreateLabel("", 24, 330, 290, 50, $SS_CENTER)
GUICtrlSetFont(-1, 16, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x008000)
GUICtrlCreateGroup("Statistik", 16, 392, 481, 209)
$pLabel_Right = GUICtrlCreateLabel("Richtig" & @CRLF & @CRLF & $iRight, 56, 416, 60, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x008000)
$pLabel_Wrong = GUICtrlCreateLabel("Falsch" & @CRLF & @CRLF & $iWrong, 160, 416, 55, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0xFF0000)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$pLabel_Average = GUICtrlCreateLabel("Durchschnitt" & @CRLF & @CRLF & "0%", 256, 416, 106, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
$pLabel_Points = GUICtrlCreateLabel("Punkte" & @CRLF & @CRLF & "0", 408, 416, 60, 62, $SS_CENTER)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlCreateGroup("Zeit", 24, 496, 465, 97)
$pLabel_AverageTime = GUICtrlCreateLabel("Durchschnitt: " & $iAverageTime & " Sekunden pro Aufgabe", 60, 519, 416, 22)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x0000FF)
$pLabel_Time = GUICtrlCreateLabel("Insgesamt: 0 Stunden, 0 Minuten, 0 Sekunden", 60, 560, 416, 22)
GUICtrlSetFont(-1, 12, 400, 0, "Verdana")
GUICtrlSetColor(-1, 0x0000FF)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$pButton_Check = GUICtrlCreateButton("berprfen", 360, 320, 129, 33, BitOR($BS_DEFPUSHBUTTON, $WS_GROUP))
GUICtrlSetState(-1, $GUI_DISABLE)
$pButton_Start = GUICtrlCreateButton("Start", 8, 616, 137, 33, $WS_GROUP)
GUICtrlSetState(-1, $GUI_FOCUS)
$pButton_Exit = GUICtrlCreateButton("Beenden", 368, 616, 137, 33, $WS_GROUP)
$pButton_Stop = GUICtrlCreateButton("Stop", 152, 616, 100, 33, $WS_GROUP)
GUICtrlSetState($pButton_Stop, $GUI_DISABLE)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $pButton_Stop
			AdlibUnRegister("_ArithTime")
			GUICtrlSetData($pLabel_Time, "Insgesamt:")
			GUICtrlSetData($pLabel_AverageTime, "Durchschnitt: - Sekunden pro Aufgabe")
			_Timer_KillAllTimers($hWindow)
			$iCurStatus = 0
			$iRight = 0
			$iWrong = 0
			GUICtrlSetState($pButton_Stop, $GUI_DISABLE)
			GUICtrlSetState($pButton_Start, $GUI_ENABLE)
			GUICtrlSetData($pLabel_Right, "Richtig" & @CRLF & @CRLF & $iRight)
			GUICtrlSetData($pLabel_Wrong, "Falsch" & @CRLF & @CRLF & $iWrong)
			GUICtrlSetData($pLabel_Output, "")
			GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & "0%")
			GUICtrlSetColor($pLabel_Average, 0)
			GUICtrlSetData($pLabel_Time, "Insgesamt: 0 Stunden, 0 Minuten, 0 Sekunden")
			GUICtrlSetState($pButton_Check, $GUI_DISABLE)
			GUICtrlSetData($pInput_Result, "")
			GUICtrlSetState($pInput_Result, $GUI_DISABLE)
			GUICtrlSetColor($pLabel_Sum, 0xC0C0C0)
			_Create_ArithmeticProblem()
			GUICtrlSetData($pInput_Result, $iCurResult)
			GUICtrlSetState($pButton_Start, $GUI_FOCUS)
		Case $pButton_Exit, $GUI_EVENT_CLOSE
			Exit
		Case $pButton_Check
			If $iCurStatus = 1 Then
				_Check_ArithmeticProblem()
			EndIf
		Case $pButton_Start
			GUICtrlSetState($pButton_Stop, $GUI_ENABLE)
			GUICtrlSetState($pButton_Check, $GUI_ENABLE)
			GUICtrlSetState($pButton_Start, $GUI_DISABLE)
			GUICtrlSetState($pInput_Result, $GUI_ENABLE)
			GUICtrlSetColor($pLabel_Sum, 0)
			GUICtrlSetColor($pInput_Result, 0)
			GUICtrlSetData($pInput_Result, "")
			GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & "0%")
			GUICtrlSetState($pInput_Result, $GUI_FOCUS)
			_Create_ArithmeticProblem()
			AdlibRegister("_ArithTime", 1000)
			$iArithTime = _Timer_Init()
			$iTimer = _Timer_Init()
		Case $pCheckbox_Sound
			If $iCurStatus = 1 Then
				GUICtrlSetState($pInput_Result, $GUI_FOCUS)
			Else
				GUICtrlSetState($pButton_Start, $GUI_FOCUS)
			EndIf
		Case $pCheckbox_Add
			If $iLastID <> $pCheckbox_Add Then
				GUICtrlSetState($pCheckbox_Add, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Add
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Add, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Sub
			If $iLastID <> $pCheckbox_Sub Then
				GUICtrlSetState($pCheckbox_Sub, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Sub
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Sub, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Mult
			If $iLastID <> $pCheckbox_Mult Then
				GUICtrlSetState($pCheckbox_Mult, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Mult
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Mult, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Div
			If $iLastID <> $pCheckbox_Div Then
				GUICtrlSetState($pCheckbox_Div, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Div
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Div, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Sqrt
			If $iLastID <> $pCheckbox_Sqrt Then
				GUICtrlSetState($pCheckbox_Sqrt, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Sqrt
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Sqrt, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Pot
			If $iLastID <> $pCheckbox_Pot Then
				GUICtrlSetState($pCheckbox_Pot, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Pot
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Pot, $GUI_CHECKED)
			EndIf
		Case $pCheckbox_Rand
			If $iLastID <> $pCheckbox_Rand Then
				GUICtrlSetState($pCheckbox_Rand, $GUI_CHECKED)
				GUICtrlSetState($iLastID, $GUI_UNCHECKED)
				If $iLastID = 24 Then _GDI_Clear()
				$iLastID = $pCheckbox_Rand
				_Create_ArithmeticProblem()
			Else
				GUICtrlSetState($pCheckbox_Rand, $GUI_CHECKED)
			EndIf
	EndSwitch
WEnd

Func _ArithTime()
	Local $Hour, $Mins, $Secs
	_TicksToTime(Int(TimerDiff($iArithTime)), $Hour, $Mins, $Secs)
	GUICtrlSetData($pLabel_Time, "Insgesamt: " & $Hour & " Stunden, " & $Mins & " Minuten, " & $Secs & " Sekunden")
EndFunc   ;==>_ArithTime

Func _GDI_Clear()
	_GDIPlus_PenDispose($hPen)
	_GDIPlus_GraphicsDispose($hGraphic)
	_GDIPlus_Shutdown()
	_WinAPI_RedrawWindow($hWindow)
EndFunc   ;==>_GDI_Clear

Func _Range($hWnd, $iMsg, $iwParam, $ilParam)
	If Not IsHWnd($pInput_HighRange) Then $hWndHR = GUICtrlGetHandle($pInput_HighRange)
	If Not IsHWnd($pInput_LowRange) Then $hWndLR = GUICtrlGetHandle($pInput_LowRange)
	Switch $ilParam
		Case $hWndHR
			If GUICtrlRead($pInput_HighRange) > 1000 Then
				GUICtrlSetData($pInput_HighRange, 1000)
			ElseIf GUICtrlRead($pInput_LowRange) = 0 And GUICtrlRead($pInput_HighRange) = 0 Then
				GUICtrlSetData($pInput_HighRange, 1)
			ElseIf GUICtrlRead($pInput_HighRange) < 0 Then
				GUICtrlSetData($pInput_HighRange, 0)
			EndIf
		Case $hWndLR
			If GUICtrlRead($pInput_LowRange) < -1000 Then
				GUICtrlSetData($pInput_LowRange, -1000)
			ElseIf GUICtrlRead($pInput_LowRange) = 0 And GUICtrlRead($pInput_HighRange) = 0 Then
				GUICtrlSetData($pInput_LowRange, 1)
			ElseIf GUICtrlRead($pInput_LowRange) > 0 Then
				GUICtrlSetData($pInput_LowRange, 0)
			EndIf
	EndSwitch
	Return $GUI_RUNDEFMSG
EndFunc   ;==>_Range

Func _Check_ArithmeticProblem()
	$iCurTime = _Timer_Diff($iTimer)
	$iLastUResult = GUICtrlRead($pInput_Result)
	If $iLastUResult == $iCurResult Then
		$iRight += 1
		GUICtrlSetData($pLabel_Right, "Richtig" & @CRLF & @CRLF & $iRight)
		GUICtrlSetData($pLabel_Output, "Richtig! " & $iLastAt)
		GUICtrlSetColor($pLabel_Output, 0x008000)
		If GUICtrlRead($pCheckbox_Sound) = 1 Then
			_SoundPlay($sSound_Right, 1)
		EndIf
	Else
		$iWrong += 1
		GUICtrlSetData($pLabel_Wrong, "Falsch" & @CRLF & @CRLF & $iWrong)
		GUICtrlSetData($pLabel_Output, "Falsch! != " & $iLastUResult & @CRLF & $iLastAt)
		GUICtrlSetColor($pLabel_Output, 0xFF0000)
		If GUICtrlRead($pCheckbox_Sound) = 1 Then
			_SoundPlay($sSound_Wrong, 1)
		EndIf
	EndIf
	$iTimeSave += ($iCurTime / 1000)
	$iAverageTime = $iTimeSave / ($iRight + $iWrong)
	GUICtrlSetData($pLabel_AverageTime, "Durchschnitt: " & Round($iAverageTime, 2) & " Sekunden pro Aufgabe")
	GUICtrlSetData($pInput_Result, "")
	GUICtrlSetState($pInput_Result, $GUI_FOCUS)
	$iAverage = Round((100 / ($iRight + $iWrong)) * $iRight, 0)
	_ArrayAdd($aAverage, $iAverage)
	GUICtrlSetData($pLabel_Average, "Durchschnitt" & @CRLF & @CRLF & $iAverage & "%")
	Switch $iAverage
		Case 0 To 50
			GUICtrlSetColor($pLabel_Average, 0xFF0000)
		Case 50 To 75
			GUICtrlSetColor($pLabel_Average, 0xFF9900)
		Case 75 To 100
			GUICtrlSetColor($pLabel_Average, 0x008000)
	EndSwitch
	If $iSq Then _GDI_Clear()
	_Create_ArithmeticProblem()
	_Timer_KillTimer($hWindow, $iTimer)
	$iTimer = _Timer_Init()
EndFunc   ;==>_Check_ArithmeticProblem

Func _Create_ArithmeticProblem()
	Local $LowR = GUICtrlRead($pInput_LowRange)
	Local $HighR = GUICtrlRead($pInput_HighRange)
	$iFirstSum = Random($LowR, $HighR, 1)
	$iSecondSum = Random($LowR, $HighR, 1)
	$iCurStatus = 1
	Switch $iLastID
		Case 20
			;- Addition
			$iCurResult = $iFirstSum + $iSecondSum
			$iLastAt = $iFirstSum & " + " & $iSecondSum
		Case 21
			;- Subtraktion
			$iCurResult = $iFirstSum - $iSecondSum
			$iLastAt = $iFirstSum & " - " & $iSecondSum
		Case 22
			;- Multiplikation
			$iCurResult = $iFirstSum * $iSecondSum
			$iLastAt = $iFirstSum & " * " & $iSecondSum
		Case 23
			;- Division
			If $iSecondSum = 0 Then
				Do
					$iSecondSum = Random($LowR, $HighR, 1)
				Until $iSecondSum <> 0
			EndIf
			$iCurResult = $iFirstSum * $iSecondSum / $iSecondSum
			$iLastAt = $iFirstSum * $iSecondSum & " / " & $iSecondSum
		Case 24
			;- Wurzel
			_GDIPlus_Startup()
			$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWindow)
			$hPen = _GDIPlus_PenCreate(0xFF000000, 4)
			Dim $ixS = 20
			Dim $iyS = 10
			_GDIPlus_GraphicsDrawLine($hGraphic, 10 + $ixS, 280 + $iyS, 26 + $ixS, 280 + $iyS, $hPen)
			_GDIPlus_GraphicsDrawLine($hGraphic, 24 + $ixS, 280 + $iyS, 50 + $ixS, 320 + $iyS, $hPen)
			_GDIPlus_GraphicsDrawLine($hGraphic, 50 + $ixS, 320 + $iyS, 65 + $ixS, 260 + $iyS, $hPen)
			_GDIPlus_GraphicsDrawLine($hGraphic, 65 + $ixS, 260 + $iyS, 300 + $ixS, 260 + $iyS, $hPen)
			$iCurResult = Sqrt($iFirstSum * $iFirstSum)
			$iLastAt = $iFirstSum * $iFirstSum
		Case 25
			;- Potenzen
			$iCurResult = $iFirstSum ^ 2
			$iLastAt = $iFirstSum & " ^2"
		Case 26
			;- Zufllige Rechenart
			Switch Random(0, 5, 1)
				Case 0
					;- Addition
					$iCurResult = $iFirstSum + $iSecondSum
					$iLastAt = $iFirstSum & " + " & $iSecondSum
				Case 1
					;- Subtraktion
					$iCurResult = $iFirstSum - $iSecondSum
					$iLastAt = $iFirstSum & " - " & $iSecondSum
				Case 2
					;- Multiplikation
					$iCurResult = $iFirstSum * $iSecondSum
					$iLastAt = $iFirstSum & " * " & $iSecondSum
				Case 3
					;- Division
					If $iSecondSum = 0 Then
						Do
							$iSecondSum = Random($LowR, $HighR, 1)
						Until $iSecondSum <> 0
					EndIf
					$iCurResult = $iFirstSum * $iSecondSum / $iSecondSum
					$iLastAt = $iFirstSum * $iSecondSum & " / " & $iSecondSum
				Case 4
					;- Wurzel
					_GDIPlus_Startup()
					$hGraphic = _GDIPlus_GraphicsCreateFromHWND($hWindow)
					$hPen = _GDIPlus_PenCreate(0xFF000000, 4)
					Dim $ixS = 20
					Dim $iyS = 10
					_GDIPlus_GraphicsDrawLine($hGraphic, 10 + $ixS, 280 + $iyS, 26 + $ixS, 280 + $iyS, $hPen)
					_GDIPlus_GraphicsDrawLine($hGraphic, 24 + $ixS, 280 + $iyS, 50 + $ixS, 320 + $iyS, $hPen)
					_GDIPlus_GraphicsDrawLine($hGraphic, 50 + $ixS, 320 + $iyS, 65 + $ixS, 260 + $iyS, $hPen)
					_GDIPlus_GraphicsDrawLine($hGraphic, 65 + $ixS, 260 + $iyS, 300 + $ixS, 260 + $iyS, $hPen)
					$iCurResult = Sqrt($iFirstSum * $iFirstSum)
					$iLastAt = $iFirstSum * $iFirstSum
					$iSq = True
				Case 5
					;- Potenzen
					$iCurResult = $iFirstSum ^ 2
					$iLastAt = $iFirstSum & " ^2"
			EndSwitch
	EndSwitch

	GUICtrlSetData($pLabel_Sum, $iLastAt)
	If $iCurStatus <> 1 Then
		GUICtrlSetData($pInput_Result, $iCurResult)
	EndIf
	$iLastAt &= " = " & $iCurResult
EndFunc   ;==>_Create_ArithmeticProblem
